OpenTTD: StationResolverObject Struct Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Data Fields
StationResolverObject Struct Reference

Station resolver. More...

`#include <newgrf_station.h>`

Inheritance diagram for StationResolverObject:

## Public Member Functions
| StationResolverObject (const StationSpec *statspec, BaseStation *st, TileIndex tile, CallbackID callback=CBID_NO_CALLBACK, uint32 callback_param1=0, uint32 callback_param2=0)
| Resolver for stations.
TownScopeResolver * | GetTown ()
| Get the town scope associated with a station, if it exists.
ScopeResolver * | GetScope (VarSpriteGroupScope scope=VSG_SCOPE_SELF, byte relative=0)
| Get a resolver for the scope.
const SpriteGroup * | ResolveReal (const RealSpriteGroup *group) const
| Get the real sprites of the grf.
Public Member Functions inherited from ResolverObject
| ResolverObject (const GRFFile *grffile, CallbackID callback=CBID_NO_CALLBACK, uint32 callback_param1=0, uint32 callback_param2=0)
| Resolver constructor.
const SpriteGroup * | Resolve ()
| Resolve SpriteGroup.
uint16 | ResolveCallback ()
| Resolve callback.
uint32 | GetRemainingTriggers () const
| Returns the waiting triggers that did not trigger any rerandomisation.
uint32 | GetReseedSum () const
| Returns the OR-sum of all bits that need reseeding independent of the scope they were accessed with.
void | ResetState ()
| Resets the dynamic state of the resolver object.

## Data Fields
StationScopeResolver | station_scope
| The station scope resolver.
TownScopeResolver * | town_scope
| The town scope resolver (created on the first call).
Data Fields inherited from ResolverObject
ScopeResolver | default_scope
| Default implementation of the grf scope.
CallbackID | callback
| Callback being resolved.
uint32 | callback_param1
| First parameter (var 10) of the callback.
uint32 | callback_param2
| Second parameter (var 18) of the callback.
uint32 | last_value
| Result of most recent DeterministicSpriteGroup (including procedure calls)
uint32 | waiting_triggers
| Waiting triggers to be used by any rerandomisation. (scope independent)
uint32 | used_triggers
| Subset of cur_triggers, which actually triggered some rerandomisation. (scope independent)
uint32 | reseed [VSG_END]
| Collects bits to rerandomise while triggering triggers.
const GRFFile * | grffile
| GRFFile the resolved SpriteGroup belongs to.
const SpriteGroup * | root_spritegroup
| Root SpriteGroup to use for resolving.

## Detailed Description

Station resolver.

Definition at line 42 of file newgrf_station.h.

## Constructor & Destructor Documentation

StationResolverObject::StationResolverObject | ( | const StationSpec * | statspec,
|  | BaseStation * | st,
|  | TileIndex | tile,
|  | CallbackID | callback = `CBID_NO_CALLBACK`,
|  | uint32 | callback_param1 = `0`,
|  | uint32 | callback_param2 = `0`
| ) |  |

Resolver for stations.

Parameters

  statspec | Station (type) specification.
  st | Instance of the station.
  tile | Tile of the station.
  callback | Callback ID.
  callback_param1 | First parameter (var 10) of the callback.
  callback_param2 | Second parameter (var 18) of the callback.

Definition at line 541 of file newgrf_station.cpp.

References _svc, GoodsEntry::cargo, StationScopeResolver::cargo_type, SpecializedStation< Station, false >::From(), Station::goods, StationSpec::grf_prop, CargoSpec::Index(), SpecializedStation< Station, false >::IsExpected(), ResolverObject::root_spritegroup, GRFFilePropsBase< Tcnt >::spritegroup, StationScopeResolver::st, station_scope, StationScopeResolver::statspec, and StationCargoList::TotalCount().

## Member Function Documentation

ScopeResolver* StationResolverObject::GetScope | ( | VarSpriteGroupScope | scope = `VSG_SCOPE_SELF`,
|  | byte | relative = `0`
| ) |  |
| inlinevirtual

Get a resolver for the scope.

Parameters

  scope | Scope to return.
  relative | Additional parameter for VSG_SCOPE_RELATIVE.

Returns
  The resolver for the requested scope.

Reimplemented from ResolverObject.

Definition at line 52 of file newgrf_station.h.

References GetTown(), station_scope, VSG_SCOPE_PARENT, and VSG_SCOPE_SELF.

TownScopeResolver * StationResolverObject::GetTown | ( |  | ) |

Get the town scope associated with a station, if it exists.

On the first call, the town scope is created (if possible).

Returns
  Town scope, if available.

Definition at line 258 of file newgrf_station.cpp.

References ClosestTownFromTile(), INVALID_TILE, StationScopeResolver::st, station_scope, StationScopeResolver::tile, BaseStation::town, and town_scope.

Referenced by GetScope().

const SpriteGroup * StationResolverObject::ResolveReal | ( | const RealSpriteGroup * | group | ) | const
| virtual

Get the real sprites of the grf.

Parameters

  group | Group to get.

Returns
  The available sprite group.

Reimplemented from ResolverObject.

Definition at line 487 of file newgrf_station.cpp.

References GoodsEntry::cargo, StationSpec::cargo_threshold, StationScopeResolver::cargo_type, CT_INVALID, StationSpec::flags, SpecializedStation< Station, false >::From(), Station::goods, OrthogonalTileArea::h, HasBit(), RealSpriteGroup::loaded, RealSpriteGroup::loading, min(), NUM_CARGO, RealSpriteGroup::num_loaded, RealSpriteGroup::num_loading, SSF_DIV_BY_STATION_SIZE, StationScopeResolver::st, STAT_CLASS_WAYP, station_scope, StationScopeResolver::statspec, StationCargoList::TotalCount(), BaseStation::train_station, and OrthogonalTileArea::w.

The documentation for this struct was generated from the following files:

- src/newgrf_station.h
- src/newgrf_station.cpp